<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="pt">
<head>
<!-- Generated by javadoc (1.8.0_221) on Tue Feb 18 11:40:30 GMT 2020 -->
<title>Graph</title>
<meta name="date" content="2020-02-18">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
<script type="text/javascript" src="../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Graph";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../Graph/DirectedNetwork.html" title="class in Graph"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../Graph/GraphADT.html" title="interface in Graph"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?Graph/Graph.html" target="_top">Frames</a></li>
<li><a href="Graph.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">Graph</div>
<h2 title="Class Graph" class="title">Class Graph&lt;T&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>Graph.Graph&lt;T&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;T&gt;</dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../Graph/DirectedGraph.html" title="class in Graph">DirectedGraph</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">Graph&lt;T&gt;</span>
extends java.lang.Object
implements <a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;T&gt;</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected boolean[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#adjMatrix">adjMatrix</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#DEFAULT_CAPACITY">DEFAULT_CAPACITY</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#DEFAULT_EXPAND_BY">DEFAULT_EXPAND_BY</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#numVertices">numVertices</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#vertices">vertices</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../Graph/Graph.html#Graph--">Graph</a></span>()</code>
<div class="block">Constructor of a Graph with a default capacity of 10</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../Graph/Graph.html#Graph-int-">Graph</a></span>(int&nbsp;capacity)</code>
<div class="block">Constructor of a Graph with a capacity given by the user</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#addEdge-int-int-">addEdge</a></span>(int&nbsp;index1,
       int&nbsp;index2)</code>
<div class="block">Inserts an edge between two vertices of the graph.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#addEdge-T-T-">addEdge</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex1,
       <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex2)</code>
<div class="block">Inserts an edge between two vertices of the graph.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#addVertex-T-">addVertex</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)</code>
<div class="block">Adds a vertex to the graph, expanding the capacity of the graph if
 necessary.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#expandCapacity--">expandCapacity</a></span>()</code>
<div class="block">Creates new array and new adj matrix with the same values as before but
 with twice the size</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#getIndex-T-">getIndex</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)</code>
<div class="block">Method that returns the index of the first ocurrence of a vertex or
 throws an exception if not found</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#indexIsValid-int-">indexIsValid</a></span>(int&nbsp;index)</code>
<div class="block">Method that validates if the index is valid</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#isConnected--">isConnected</a></span>()</code>
<div class="block">Method that returns true if the graph is connected and false otherwise</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#isEmpty--">isEmpty</a></span>()</code>
<div class="block">Method that returns true if the graphic is empty</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorBFS-int-">iteratorBFS</a></span>(int&nbsp;startIndex)</code>
<div class="block">Returns an iterator that performs a breadth first search traversal
 starting at the given index.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>java.util.Iterator</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorBFS-T-">iteratorBFS</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex)</code>
<div class="block">Returns a breadth first iterator starting with the given vertex.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>private java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorDFS-int-">iteratorDFS</a></span>(int&nbsp;startIndex)</code>
<div class="block">Returns an iterator that performs a depth first search traversal starting
 at the given index.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>java.util.Iterator</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorDFS-T-">iteratorDFS</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex)</code>
<div class="block">Returns a depth first iterator starting with the given vertex.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>private java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorShortestPath-int-int-">iteratorShortestPath</a></span>(int&nbsp;startIndex,
                    int&nbsp;targetIndex)</code>
<div class="block">Returns an iterator that contains the shortest path between the two
 indexes.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>java.util.Iterator</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#iteratorShortestPath-T-T-">iteratorShortestPath</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex,
                    <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;targetVertex)</code>
<div class="block">Returns an iterator that contains the shortest path between the two
 vertices.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#removeEdge-int-int-">removeEdge</a></span>(int&nbsp;index1,
          int&nbsp;index2)</code>
<div class="block">Removes an edge between 2 vertices in a graph using their index</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#removeEdge-T-T-">removeEdge</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex1,
          <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex2)</code>
<div class="block">Removes an edge between 2 vertices in a graph using the private method to
 remove edges using index</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#removeVertex-int-">removeVertex</a></span>(int&nbsp;index)</code>
<div class="block">Removes a vertex in a given index from the graph</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#removeVertex-T-">removeVertex</a></span>(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)</code>
<div class="block">Search for a Vertex in the graph and if exists, removes it using his
 index</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../Graph/Graph.html#size--">size</a></span>()</code>
<div class="block">Method that returns the number of vertices of the graph</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.Graph.GraphADT">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;Graph.<a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a></h3>
<code><a href="../Graph/GraphADT.html#toString--">toString</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="DEFAULT_EXPAND_BY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEFAULT_EXPAND_BY</h4>
<pre>protected final&nbsp;int DEFAULT_EXPAND_BY</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#Graph.Graph.DEFAULT_EXPAND_BY">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="DEFAULT_CAPACITY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEFAULT_CAPACITY</h4>
<pre>protected final&nbsp;int DEFAULT_CAPACITY</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#Graph.Graph.DEFAULT_CAPACITY">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="numVertices">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>numVertices</h4>
<pre>protected&nbsp;int numVertices</pre>
</li>
</ul>
<a name="adjMatrix">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>adjMatrix</h4>
<pre>protected&nbsp;boolean[][] adjMatrix</pre>
</li>
</ul>
<a name="vertices">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>vertices</h4>
<pre>protected&nbsp;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>[] vertices</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Graph--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Graph</h4>
<pre>public&nbsp;Graph()</pre>
<div class="block">Constructor of a Graph with a default capacity of 10</div>
</li>
</ul>
<a name="Graph-int-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Graph</h4>
<pre>public&nbsp;Graph(int&nbsp;capacity)</pre>
<div class="block">Constructor of a Graph with a capacity given by the user</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>capacity</code> - inicial capacity of the graph</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="addEdge-java.lang.Object-java.lang.Object-">
<!--   -->
</a><a name="addEdge-T-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addEdge</h4>
<pre>public&nbsp;void&nbsp;addEdge(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex1,
                    <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex2)</pre>
<div class="block">Inserts an edge between two vertices of the graph.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#addEdge-T-T-">addEdge</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertex1</code> - the first vertex</dd>
<dd><code>vertex2</code> - the second vertex</dd>
</dl>
</li>
</ul>
<a name="addEdge-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addEdge</h4>
<pre>private&nbsp;void&nbsp;addEdge(int&nbsp;index1,
                     int&nbsp;index2)</pre>
<div class="block">Inserts an edge between two vertices of the graph.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>index1</code> - the first index</dd>
<dd><code>index2</code> - the second index</dd>
</dl>
</li>
</ul>
<a name="addVertex-java.lang.Object-">
<!--   -->
</a><a name="addVertex-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addVertex</h4>
<pre>public&nbsp;void&nbsp;addVertex(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)</pre>
<div class="block">Adds a vertex to the graph, expanding the capacity of the graph if
 necessary. It also associates an object with the vertex.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#addVertex-T-">addVertex</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertex</code> - the vertex to add to the graph</dd>
</dl>
</li>
</ul>
<a name="removeVertex-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeVertex</h4>
<pre>private&nbsp;void&nbsp;removeVertex(int&nbsp;index)</pre>
<div class="block">Removes a vertex in a given index from the graph</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>index</code> - index of the vertex to remove</dd>
</dl>
</li>
</ul>
<a name="removeVertex-java.lang.Object-">
<!--   -->
</a><a name="removeVertex-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeVertex</h4>
<pre>public&nbsp;void&nbsp;removeVertex(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)
                  throws <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></pre>
<div class="block">Search for a Vertex in the graph and if exists, removes it using his
 index</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#removeVertex-T-">removeVertex</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertex</code> - vertex to remove from the graph</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
</dl>
</li>
</ul>
<a name="removeEdge-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeEdge</h4>
<pre>private&nbsp;void&nbsp;removeEdge(int&nbsp;index1,
                        int&nbsp;index2)</pre>
<div class="block">Removes an edge between 2 vertices in a graph using their index</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>index1</code> - index of the first vertex</dd>
<dd><code>index2</code> - index of the second vertex</dd>
</dl>
</li>
</ul>
<a name="removeEdge-java.lang.Object-java.lang.Object-">
<!--   -->
</a><a name="removeEdge-T-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeEdge</h4>
<pre>public&nbsp;void&nbsp;removeEdge(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex1,
                       <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex2)
                throws <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></pre>
<div class="block">Removes an edge between 2 vertices in a graph using the private method to
 remove edges using index</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#removeEdge-T-T-">removeEdge</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertex1</code> - start vertex</dd>
<dd><code>vertex2</code> - target vertex</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
</dl>
</li>
</ul>
<a name="iteratorBFS-java.lang.Object-">
<!--   -->
</a><a name="iteratorBFS-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorBFS</h4>
<pre>public&nbsp;java.util.Iterator&nbsp;iteratorBFS(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex)
                               throws <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></pre>
<div class="block">Returns a breadth first iterator starting with the given vertex.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#iteratorBFS-T-">iteratorBFS</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startVertex</code> - the starting vertex</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a breadth first iterator beginning at the given vertex</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
</dl>
</li>
</ul>
<a name="iteratorBFS-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorBFS</h4>
<pre>private&nbsp;java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;&nbsp;iteratorBFS(int&nbsp;startIndex)</pre>
<div class="block">Returns an iterator that performs a breadth first search traversal
 starting at the given index.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startIndex</code> - the index to begin the search from</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an iterator that performs a breadth first traversal</dd>
</dl>
</li>
</ul>
<a name="iteratorDFS-java.lang.Object-">
<!--   -->
</a><a name="iteratorDFS-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorDFS</h4>
<pre>public&nbsp;java.util.Iterator&nbsp;iteratorDFS(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex)
                               throws <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a>,
                                      <a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></pre>
<div class="block">Returns a depth first iterator starting with the given vertex.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#iteratorDFS-T-">iteratorDFS</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startVertex</code> - the starting vertex</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a depth first iterator starting at the given vertex</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
<dd><code><a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></code> - if the collection is empty</dd>
</dl>
</li>
</ul>
<a name="iteratorDFS-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorDFS</h4>
<pre>private&nbsp;java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;&nbsp;iteratorDFS(int&nbsp;startIndex)
                                   throws <a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></pre>
<div class="block">Returns an iterator that performs a depth first search traversal starting
 at the given index.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startIndex</code> - the index to begin the search traversal from</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an iterator that performs a depth first traversal</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></code> - if the collection is empty</dd>
</dl>
</li>
</ul>
<a name="iteratorShortestPath-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorShortestPath</h4>
<pre>private&nbsp;java.util.Iterator&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;&nbsp;iteratorShortestPath(int&nbsp;startIndex,
                                                   int&nbsp;targetIndex)
                                            throws <a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></pre>
<div class="block">Returns an iterator that contains the shortest path between the two
 indexes.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startIndex</code> - the starting vertex index</dd>
<dd><code>targetIndex</code> - the ending vertex index</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an iterator that contains the shortest path between the two
 vertices</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></code> - if the collection is empty</dd>
</dl>
</li>
</ul>
<a name="iteratorShortestPath-java.lang.Object-java.lang.Object-">
<!--   -->
</a><a name="iteratorShortestPath-T-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iteratorShortestPath</h4>
<pre>public&nbsp;java.util.Iterator&nbsp;iteratorShortestPath(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;startVertex,
                                               <a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;targetVertex)
                                        throws <a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a>,
                                               <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></pre>
<div class="block">Returns an iterator that contains the shortest path between the two
 vertices.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#iteratorShortestPath-T-T-">iteratorShortestPath</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>startVertex</code> - the starting vertex</dd>
<dd><code>targetVertex</code> - the ending vertex</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an iterator that contains the shortest path between the two
 vertices</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyCollectionException.html" title="class in Exceptions">EmptyCollectionException</a></code> - if the collection is empty</dd>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
</dl>
</li>
</ul>
<a name="isEmpty--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre>public&nbsp;boolean&nbsp;isEmpty()</pre>
<div class="block">Method that returns true if the graphic is empty</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#isEmpty--">isEmpty</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the graph is empty false otherwise</dd>
</dl>
</li>
</ul>
<a name="isConnected--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConnected</h4>
<pre>public&nbsp;boolean&nbsp;isConnected()</pre>
<div class="block">Method that returns true if the graph is connected and false otherwise</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#isConnected--">isConnected</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the graph is connected</dd>
</dl>
</li>
</ul>
<a name="size--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>public&nbsp;int&nbsp;size()</pre>
<div class="block">Method that returns the number of vertices of the graph</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Graph/GraphADT.html#size--">size</a></code>&nbsp;in interface&nbsp;<code><a href="../Graph/GraphADT.html" title="interface in Graph">GraphADT</a>&lt;<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>number of vertices of the graph</dd>
</dl>
</li>
</ul>
<a name="getIndex-java.lang.Object-">
<!--   -->
</a><a name="getIndex-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getIndex</h4>
<pre>public&nbsp;int&nbsp;getIndex(<a href="../Graph/Graph.html" title="type parameter in Graph">T</a>&nbsp;vertex)
             throws <a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></pre>
<div class="block">Method that returns the index of the first ocurrence of a vertex or
 throws an exception if not found</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertex</code> - vertex to get the index</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the index of the first ocurrence of a vertex or -1 if not found</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../Exceptions/ElementNotFoundException.html" title="class in Exceptions">ElementNotFoundException</a></code> - if the element isn't found</dd>
</dl>
</li>
</ul>
<a name="indexIsValid-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>indexIsValid</h4>
<pre>public&nbsp;boolean&nbsp;indexIsValid(int&nbsp;index)</pre>
<div class="block">Method that validates if the index is valid</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>index</code> - index to check</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the given index is valid</dd>
</dl>
</li>
</ul>
<a name="expandCapacity--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>expandCapacity</h4>
<pre>protected&nbsp;void&nbsp;expandCapacity()</pre>
<div class="block">Creates new array and new adj matrix with the same values as before but
 with twice the size</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../Graph/DirectedNetwork.html" title="class in Graph"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../Graph/GraphADT.html" title="interface in Graph"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?Graph/Graph.html" target="_top">Frames</a></li>
<li><a href="Graph.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
